package com.fundi.framework.common.displaylist;

/*
 *  Common Services Library - Framework plug-in.
 *  (C) Copyright Fundi Software 2011, 2016.  Fundi Confidential.
 *  All rights reserved.  Use, duplication or disclosure restricted. 
 */

import java.util.Arrays;

import com.fundi.framework.common.nl1.Messages;
import com.fundi.framework.common.util.StringEditor;

public class SummaryGroup  implements Comparable<SummaryGroup> {

	//Eye catchers.
	public static final String EC_COPYRIGHT = "(C) Copyright 2011, 2016 Fundi Software.  Fundi Confidential."; //$NON-NLS-1$
	public static final String EC_APAR = "3.1.1.00_00014"; //$NON-NLS-1$
	public static final String EC_FMID = "H30SA10"; //$NON-NLS-1$
	public static final String EC_PID = "5655-CSL"; //$NON-NLS-1$
	
	private String[] fieldValues;
	private int count;
	
	public SummaryGroup(String[] fieldValues) {
	
		super();

		this.fieldValues = fieldValues;
		count = 1;
	}

	public String[] getFieldValues() {
		return fieldValues;
	}

	public int getCount() {
		
		return count;
	}
	
	public void incrementCount() {
		
		count++;
	}

	public void setCount(int count) {
		
		this.count = count;
	}
	
	public String getCompareValue() {
		
		String key = ""; //$NON-NLS-1$
		int idx;
		
		for (idx = 0; idx < fieldValues.length; idx++) {
			if (fieldValues[idx] != null) {
				key = key + (new StringEditor(fieldValues[idx])).pad(50);
			}
			else {
				key = key + (new StringEditor(" ")).pad(50);
			}
		}
		
		return key;
	}

	@Override
	public int compareTo(SummaryGroup o) {

		int comparison;
		
		comparison = getCompareValue().compareTo(o.getCompareValue());
		
		return comparison;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + Arrays.hashCode(fieldValues);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		SummaryGroup other = (SummaryGroup) obj;
		if (!Arrays.equals(fieldValues, other.fieldValues))
			return false;
		return true;
	}
}
