package com.fundi.framework.common.editor;

/*
 *  Common Services Library - Framework plug-in.
 *  (C) Copyright Fundi Software 2011, 2016.  Fundi Confidential.
 *  All rights reserved.  Use, duplication or disclosure restricted. 
 */

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import com.fundi.framework.common.comparator.ComparatorSource;
import com.fundi.framework.common.displaylist.DisplayList;
import com.fundi.framework.common.instance.AppInstance;

public class SavedDisplay extends ComparatorSource {
	
	//Eye catchers.
	public static final String EC_COPYRIGHT = "(C) Copyright 2011, 2016 Fundi Software.  Fundi Confidential."; //$NON-NLS-1$
	public static final String EC_APAR = "3.1.1.00_00014"; //$NON-NLS-1$
	public static final String EC_FMID = "H30SA10"; //$NON-NLS-1$
	public static final String EC_PID = "5655-CSL"; //$NON-NLS-1$
	
	private String editorTitle = "";
	private Map<String, String> comparatorSources = new HashMap<String, String>();
	private Map<String, DisplayList> lists = new HashMap<String, DisplayList>();
	private Map<String, Object> extraData = new HashMap<String, Object>();
	
	private String filePath = "";

	public SavedDisplay(AppInstance instance) {

		super("", null);
	}

	public String getEditorTitle() {
		
		return editorTitle;
	}

	public void setEditorTitle(String editorTitle) {
		
		this.editorTitle = editorTitle;
	}
	
	public DisplayList getList() {
		
		if (lists.size() > 0) {
			return lists.values().iterator().next();  //Just need the first one.  This method is assuming there is only one.
		}
		else {
			return null;
		}
	}
	
	public void addList(DisplayList list) {
		
		lists.put(list.getTitle(), list);
	}
	
	public ArrayList<String> getTitles() {
		
		Iterator<String> itTitle;
		Set<String> titles = lists.keySet();
		ArrayList<String> retTitles = new ArrayList<String>();
		
		for (itTitle = titles.iterator(); itTitle.hasNext();) {
			retTitles.add((String) itTitle.next());
		}
		return retTitles;
	}

	public ArrayList<String> getComparatorSourceTitles() {
		
		Iterator<String> itTitle;
		Set<String> titles = comparatorSources.keySet();
		ArrayList<String> retTitles = new ArrayList<String>();
		
		for (itTitle = titles.iterator(); itTitle.hasNext();) {
			retTitles.add(getTitle() + "/" + (String) itTitle.next());  //For the comparator, so prefix the source title with the editor's title.
		}
		return retTitles;
	}

	public ArrayList<DisplayList> getLists() {
		
		Iterator<DisplayList> itMap;
		Collection<DisplayList> displayLists = lists.values();
		ArrayList<DisplayList> retLists = new ArrayList<DisplayList>();
		
		for (itMap = displayLists.iterator(); itMap.hasNext();) {
			retLists.add((DisplayList) itMap.next());
		}
		return retLists;
	}
	
	public void addExtraData(String name, Object data) {
		
		extraData.put(name, data);
	}
	
	public Object getExtraData(String name) {
		
		return extraData.get(name);
	}

	public void setFilePath(String filePath) {
		
		this.filePath = filePath;
	}
	
	public String getFilePath() {
		
		return filePath;
	}

	public void setComparatorSources(Map<String, String> comparatorSources) {
		
		this.comparatorSources = comparatorSources;
	}
}
